Index: sys/arch/x86/pci/pchb.c
===================================================================
RCS file: /cvsroot/src/sys/arch/x86/pci/pchb.c,v
retrieving revision 1.21
diff -u -r1.21 pchb.c
--- sys/arch/x86/pci/pchb.c	24 Feb 2010 22:37:55 -0000	1.21
+++ sys/arch/x86/pci/pchb.c	16 Jun 2010 03:07:22 -0000
@@ -386,6 +386,14 @@
 		case PCI_PRODUCT_INTEL_82IGD_E_HB:
 		case PCI_PRODUCT_INTEL_82Q45_HB:
 		case PCI_PRODUCT_INTEL_82G45_HB:
+		case PCI_PRODUCT_INTEL_82G41_HB:
+		case PCI_PRODUCT_INTEL_E7221_HB:
+		case PCI_PRODUCT_INTEL_82965GME_HB:
+		case PCI_PRODUCT_INTEL_82B43_HB:
+		case PCI_PRODUCT_INTEL_IRONLAKE_D_HB:
+		case PCI_PRODUCT_INTEL_IRONLAKE_M_HB:
+		case PCI_PRODUCT_INTEL_IRONLAKE_MA_HB:
+		case PCI_PRODUCT_INTEL_IRONLAKE_MC2_HB:
 			/*
 			 * The host bridge is either in GFX mode (internal
 			 * graphics) or in AGP mode. In GFX mode, we pretend
Index: sys/dev/pci/agp.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/agp.c,v
retrieving revision 1.68
diff -u -r1.68 agp.c
--- sys/dev/pci/agp.c	24 Feb 2010 22:37:59 -0000	1.68
+++ sys/dev/pci/agp.c	16 Jun 2010 03:07:23 -0000
@@ -192,6 +192,22 @@
 	  NULL, 		agp_i810_attach },
 	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_82G45_HB,
 	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_82G41_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_E7221_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_82965GME_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_82B43_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_IRONLAKE_D_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_IRONLAKE_M_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_IRONLAKE_MA_HB,
+	  NULL, 		agp_i810_attach },
+	{ PCI_VENDOR_INTEL,	PCI_PRODUCT_INTEL_IRONLAKE_MC2_HB,
+	  NULL, 		agp_i810_attach },
 #endif
 
 #if NAGP_INTEL > 0
Index: sys/dev/pci/agp_i810.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/agp_i810.c,v
retrieving revision 1.67
diff -u -r1.67 agp_i810.c
--- sys/dev/pci/agp_i810.c	4 Apr 2010 14:40:05 -0000	1.67
+++ sys/dev/pci/agp_i810.c	16 Jun 2010 03:07:24 -0000
@@ -171,6 +171,7 @@
 	case PCI_PRODUCT_INTEL_82945GM_IGD:
 	case PCI_PRODUCT_INTEL_82945GM_IGD_1:
 	case PCI_PRODUCT_INTEL_82945GME_IGD:
+	case PCI_PRODUCT_INTEL_E7221_IGD:
 	case PCI_PRODUCT_INTEL_82965Q_IGD:
 	case PCI_PRODUCT_INTEL_82965Q_IGD_1:
 	case PCI_PRODUCT_INTEL_82965PM_IGD:
@@ -179,6 +180,7 @@
 	case PCI_PRODUCT_INTEL_82G33_IGD_1:
 	case PCI_PRODUCT_INTEL_82965G_IGD:
 	case PCI_PRODUCT_INTEL_82965G_IGD_1:
+	case PCI_PRODUCT_INTEL_82965GME_IGD:
 	case PCI_PRODUCT_INTEL_82Q35_IGD:
 	case PCI_PRODUCT_INTEL_82Q35_IGD_1:
 	case PCI_PRODUCT_INTEL_82Q33_IGD:
@@ -191,6 +193,10 @@
 	case PCI_PRODUCT_INTEL_82IGD_E_IGD:
 	case PCI_PRODUCT_INTEL_82Q45_IGD:
 	case PCI_PRODUCT_INTEL_82G45_IGD:
+	case PCI_PRODUCT_INTEL_82G41_IGD:
+	case PCI_PRODUCT_INTEL_82B43_IGD:
+	case PCI_PRODUCT_INTEL_IRONLAKE_D_IGD:
+	case PCI_PRODUCT_INTEL_IRONLAKE_M_IGD:
 		return (1);
 	}
 
@@ -274,6 +280,7 @@
 	case PCI_PRODUCT_INTEL_82945GM_IGD:
 	case PCI_PRODUCT_INTEL_82945GM_IGD_1:
 	case PCI_PRODUCT_INTEL_82945GME_IGD:
+	case PCI_PRODUCT_INTEL_E7221_IGD:
 		isc->chiptype = CHIP_I915;
 		break;
 	case PCI_PRODUCT_INTEL_82965Q_IGD:
@@ -282,6 +289,7 @@
 	case PCI_PRODUCT_INTEL_82965PM_IGD_1:
 	case PCI_PRODUCT_INTEL_82965G_IGD:
 	case PCI_PRODUCT_INTEL_82965G_IGD_1:
+	case PCI_PRODUCT_INTEL_82965GME_IGD:
 	case PCI_PRODUCT_INTEL_82946GZ_IGD:
 	case PCI_PRODUCT_INTEL_82G35_IGD:
 	case PCI_PRODUCT_INTEL_82G35_IGD_1:
@@ -300,6 +308,10 @@
 	case PCI_PRODUCT_INTEL_82IGD_E_IGD:
 	case PCI_PRODUCT_INTEL_82Q45_IGD:
 	case PCI_PRODUCT_INTEL_82G45_IGD:
+	case PCI_PRODUCT_INTEL_82G41_IGD:
+	case PCI_PRODUCT_INTEL_82B43_IGD:
+	case PCI_PRODUCT_INTEL_IRONLAKE_D_IGD:
+	case PCI_PRODUCT_INTEL_IRONLAKE_M_IGD:
 		isc->chiptype = CHIP_G4X;
 		break;
 	}
Index: sys/dev/pci/pcidevs
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/pcidevs,v
retrieving revision 1.1034
diff -u -r1.1034 pcidevs
--- sys/dev/pci/pcidevs	8 Jun 2010 13:22:04 -0000	1.1034
+++ sys/dev/pci/pcidevs	16 Jun 2010 03:07:28 -0000
@@ -2219,6 +2219,16 @@
 product IMS TT128M	0x9128	TwinTurbo 128M
 
 /* Intel products */
+product INTEL IRONLAKE_D_HB	0x0040	Iron Lake Host Bridge
+product INTEL IRONLAKE_D_IGD	0x0042	Iron Lake Integrated Graphics Device
+product INTEL IRONLAKE_M_HB	0x0044	Iron Lake Host Bridge
+product INTEL IRONLAKE_M_IGD	0x0046	Iron Lake Integrated Graphics Device
+product INTEL IRONLAKE_MA_HB	0x0062	Iron Lake Host Bridge
+product INTEL IRONLAKE_MC2_HB	0x006a	Iron Lake Host Bridge
+product INTEL SANDYBRIDGE_HB	0x0100	Sandy Bridge Host Bridge
+product INTEL SANDYBRIDGE_IGD	0x0102	Sandy Bridge Integrated Graphics Device
+product INTEL SANDYBRIDGE_M_HB	0x0104	Sandy Bridge Host Bridge
+product INTEL SANDYBRIDGE_M_IGD	0x0106	Sandy Bridge Integrated Graphics Device
 product INTEL 80312		0x030d	80312 I/O Companion Chip
 product INTEL 80321		0x0319	80321 I/O Processor
 product INTEL IOP333_A		0x0370	IOP333 PCI Express-to-PCI Bridge #0
@@ -2508,6 +2518,9 @@
 product INTEL 82915G_IGD	0x2582	82915G/GL Integrated Graphics Device
 product INTEL 82925X_HB		0x2584	82925X Host
 product INTEL 82925X_EX		0x2585	82925X PCI Express Bridge
+product INTEL E7221_HB		0x2588	E7221 Host Bridge
+product INTEL E7221_IGD		0x258a	E7221 Integrated Graphics Device
+product INTEL 82915G_IGD	0x2582	82915G/GL Integrated Graphics Device
 product INTEL 82915GM_HB	0x2590	82915PM/GM/GMS,82910GML Host Bridge
 product INTEL 82915GM_EX	0x2591	82915PM/GM PCI Express Bridge
 product INTEL 82915GM_IGD	0x2592	82915GM/GMS,82910GML Integrated Graphics Device
@@ -2712,6 +2725,8 @@
 product INTEL 82965PM_MEI	0x2a04	82965PM MEI Controller
 product INTEL 82965PM_IDE	0x2a06	82965PM IDE Interface
 product INTEL 82965PM_KT	0x2a07	82965PM Serial Interface
+product INTEL 82965GME_HB	0x2a10	82965GME Host Bridge
+product INTEL 82965GME_IGD	0x2a12	82965GME Integrated Graphics Device
 product INTEL 82GM45_HB		0x2a40	82GM45 Host Bridge
 product INTEL 82GM45_IGD	0x2a42	82GM45 Integrated Graphics Device
 product INTEL 82GM45_IGD_1	0x2a43	82GM45 Integrated Graphics Device
@@ -2721,6 +2736,10 @@
 product INTEL 82Q45_IGD		0x2e12	82Q45 Integrated Graphics Device
 product INTEL 82G45_HB		0x2e20	82G45 Host Bridge
 product INTEL 82G45_IGD		0x2e22	82G45 Integrated Graphics Device
+product INTEL 82G41_HB		0x2e30	82G41 Host Bridge
+product INTEL 82G41_IGD		0x2e32	82G41 Integrated Graphics Device
+product INTEL 82B43_HB		0x2e40	82B43 Host Bridge
+product INTEL 82B43_IGD		0x2e42	82B43 Integrated Graphics Device
 product INTEL 31244		0x3200	31244 Serial ATA Controller
 product INTEL 82855PM_DDR	0x3340	82855PM MCH Host Controller
 product INTEL 82855PM_AGP	0x3341	82855PM Host-AGP Bridge
@@ -2844,6 +2863,10 @@
 product INTEL PCI450_MC		0x84c5	82451KX/GX Memory Controller (MC)
 product INTEL 82451NX_MIOC	0x84ca	82451NX Memory & I/O Controller (MIOC)
 product INTEL 82451NX_PXB	0x84cb	82451NX PCI Expander Bridge (PXB)
+product INTEL PINEVIEW_HB	0xa000	Pineview Host Bridge
+product INTEL PINEVIEW_IGD	0xa001	Pineview Integrated Graphics Device
+product INTEL PINEVIEW_M_HB	0xa010	Pineview Host Bridge
+product INTEL PINEVIEW_M_IGD	0xa011	Pineview Integrated Graphics Device
 product INTEL 21152		0xb152	S21152BB PCI-PCI Bridge
 product INTEL 21154		0xb154	S21152BA,S21154AE/BE PCI-PCI Bridge
 product INTEL 21555		0xb555	21555 Non-Transparent PCI-PCI Bridge