? sbin/devpubd/.gdbinit
Index: distrib/sets/lists/etc/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/etc/mi,v
retrieving revision 1.224
diff -u -r1.224 mi
--- distrib/sets/lists/etc/mi	27 May 2011 09:28:41 -0000	1.224
+++ distrib/sets/lists/etc/mi	6 Sep 2011 20:22:57 -0000
@@ -183,6 +183,7 @@
 ./etc/rc.d/cgd					etc-sys-rc
 ./etc/rc.d/cleartmp				etc-sys-rc
 ./etc/rc.d/cron					etc-cron-rc
+./etc/rc.d/devpubd				etc-sys-rc
 ./etc/rc.d/dhclient				etc-dhclient-rc
 ./etc/rc.d/dhcpcd				etc-dhcpcd-rc
 ./etc/rc.d/dhcpd				etc-dhcpd-rc
Index: distrib/sets/lists/man/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/man/mi,v
retrieving revision 1.1338
diff -u -r1.1338 mi
--- distrib/sets/lists/man/mi	30 Aug 2011 07:07:05 -0000	1.1338
+++ distrib/sets/lists/man/mi	6 Sep 2011 20:22:58 -0000
@@ -2203,6 +2203,7 @@
 ./usr/share/man/cat8/dbsym.0			man-sysutil-catman	binutils,.cat
 ./usr/share/man/cat8/defer.0			man-postfix-catman	postfix,.cat
 ./usr/share/man/cat8/dev_mkdb.0			man-sysutil-catman	.cat
+./usr/share/man/cat8/devpubd.0			man-sysutil-catman	.cat
 ./usr/share/man/cat8/dhclient-script.0		man-dhclient-catman	.cat
 ./usr/share/man/cat8/dhclient.0			man-dhclient-catman	.cat
 ./usr/share/man/cat8/dhcpcd-run-hooks.0		man-dhcpcd-catman	.cat
@@ -4882,6 +4883,7 @@
 ./usr/share/man/html8/dbsym.html		man-sysutil-htmlman	binutils,html
 ./usr/share/man/html8/defer.html		man-postfix-htmlman	postfix,html
 ./usr/share/man/html8/dev_mkdb.html		man-sysutil-htmlman	html
+./usr/share/man/html8/devpubd.html		man-sysutil-htmlman	html
 ./usr/share/man/html8/dhclient-script.html	man-dhclient-htmlman	html
 ./usr/share/man/html8/dhclient.html		man-dhclient-htmlman	html
 ./usr/share/man/html8/dhcpcd-run-hooks.html	man-dhcpcd-htmlman	html
@@ -7617,6 +7619,7 @@
 ./usr/share/man/man8/dbsym.8			man-sysutil-man		binutils,.man
 ./usr/share/man/man8/defer.8			man-postfix-man		postfix,.man
 ./usr/share/man/man8/dev_mkdb.8			man-sysutil-man		.man
+./usr/share/man/man8/devpubd.8			man-sysutil-man		.man
 ./usr/share/man/man8/dhclient-script.8		man-dhclient-man	.man
 ./usr/share/man/man8/dhclient.8			man-dhclient-man	.man
 ./usr/share/man/man8/dhcpcd-run-hooks.8		man-dhcpcd-man		.man
Index: etc/defaults/rc.conf
===================================================================
RCS file: /cvsroot/src/etc/defaults/rc.conf,v
retrieving revision 1.114
diff -u -r1.114 rc.conf
--- etc/defaults/rc.conf	22 Aug 2011 18:54:06 -0000	1.114
+++ etc/defaults/rc.conf	6 Sep 2011 20:22:59 -0000
@@ -316,6 +316,7 @@
 # Other daemons.
 #
 rwhod=NO		rwhod_flags="-u _rwhod"
+devpubd=NO		devpubd_flags=""	# autocreate nodes for new devs
 envsys=NO					# Set /etc/envsys.conf preferences
 
 # Hardware daemons.
Index: etc/rc.d/Makefile
===================================================================
RCS file: /cvsroot/src/etc/rc.d/Makefile,v
retrieving revision 1.84
diff -u -r1.84 Makefile
--- etc/rc.d/Makefile	27 May 2011 09:28:42 -0000	1.84
+++ etc/rc.d/Makefile	6 Sep 2011 20:22:59 -0000
@@ -17,7 +17,7 @@
 		DAEMON DISKS LOGIN NETWORKING SERVERS \
 		accounting altqd amd apmd \
 		bluetooth bootconf.sh bootparams \
-		ccd cgd cleartmp cron \
+		ccd cgd cleartmp cron devpubd \
 		dhclient dhcpcd dhcpd dhcrelay dmesg downinterfaces envsys \
 		fsck fsck_root ftp_proxy ftpd \
 		gpio \
Index: etc/rc.d/devpubd
===================================================================
RCS file: etc/rc.d/devpubd
diff -N etc/rc.d/devpubd
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ etc/rc.d/devpubd	6 Sep 2011 20:22:59 -0000
@@ -0,0 +1,17 @@
+#!/bin/sh
+#
+# $NetBSD$
+#
+
+# PROVIDE: devpubd
+# REQUIRE: DAEMON
+# BEFORE:  LOGIN
+
+$_rc_subr_loaded . /etc/rc.subr
+
+name="devpubd"
+rcvar=$name
+command="/sbin/${name}"
+
+load_rc_config $name
+run_rc_command "$1"
Index: sbin/devpubd/Makefile
===================================================================
RCS file: /cvsroot/src/sbin/devpubd/Makefile,v
retrieving revision 1.1
diff -u -r1.1 Makefile
--- sbin/devpubd/Makefile	29 Aug 2011 11:38:48 -0000	1.1
+++ sbin/devpubd/Makefile	6 Sep 2011 20:23:37 -0000
@@ -2,7 +2,7 @@
 
 PROG=		devpubd
 SRCS=		devpubd.c
-NOMAN=		# defined
+MAN=		devpubd.8
 WARNS=		4
 
 BINDIR?=	/sbin