Index: distrib/sets/lists/comp/gcc.mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/comp/gcc.mi,v
retrieving revision 1.13
diff -u -r1.13 gcc.mi
--- distrib/sets/lists/comp/gcc.mi	13 May 2006 07:17:54 -0000	1.13
+++ distrib/sets/lists/comp/gcc.mi	17 May 2006 19:12:08 -0000
@@ -321,9 +321,9 @@
 ./usr/lib/libgcc_p.a				comp-c-proflib		profile
 ./usr/lib/libsupc++.a				comp-cxx-lib
 ./usr/libexec/f771				comp-fortran-bin	gcccmds
-./usr/share/man/cat1/f77.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/fort77.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/g77.0			comp-fortran-catman	.cat
-./usr/share/man/man1/f77.1			comp-fortran-man	.man
-./usr/share/man/man1/fort77.1			comp-fortran-man	.man
-./usr/share/man/man1/g77.1			comp-fortran-man	.man
+./usr/share/man/cat1/f77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/cat1/fort77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/cat1/g77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/man1/f77.1			comp-fortran-man	gcccmds,.man
+./usr/share/man/man1/fort77.1			comp-fortran-man	gcccmds,.man
+./usr/share/man/man1/g77.1			comp-fortran-man	gcccmds,.man
Index: distrib/sets/lists/comp/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/comp/mi,v
retrieving revision 1.881
diff -u -r1.881 mi
--- distrib/sets/lists/comp/mi	16 May 2006 21:51:34 -0000	1.881
+++ distrib/sets/lists/comp/mi	17 May 2006 19:12:10 -0000
@@ -1953,11 +1953,11 @@
 ./usr/share/man/cat1/ar.0			comp-util-catman	bfd,.cat
 ./usr/share/man/cat1/as.0			comp-util-catman	bfd,.cat
 ./usr/share/man/cat1/asa.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/c++.0			comp-cxx-catman		.cat
+./usr/share/man/cat1/c++.0			comp-cxx-catman		gcccmds,.cat
 ./usr/share/man/cat1/c++filt.0			comp-cxx-catman		bfd,.cat
 ./usr/share/man/cat1/c89.0			comp-c-catman		.cat
-./usr/share/man/cat1/cc.0			comp-c-catman		.cat
-./usr/share/man/cat1/cccp.0			comp-util-catman	.cat
+./usr/share/man/cat1/cc.0			comp-c-catman		gcccmds,.cat
+./usr/share/man/cat1/cccp.0			comp-util-catman	gcccmds,.cat
 ./usr/share/man/cat1/config.0			comp-util-catman	.cat
 ./usr/share/man/cat1/crunchgen.0		comp-c-catman		.cat
 ./usr/share/man/cat1/crunchide.0		comp-c-catman		.cat
@@ -1968,10 +1968,10 @@
 ./usr/share/man/cat1/flex.0			comp-c-catman		.cat
 ./usr/share/man/cat1/flexdoc.0			comp-obsolete		obsolete
 ./usr/share/man/cat1/fpr.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/g++.0			comp-cxx-catman		.cat
-./usr/share/man/cat1/gcc.0			comp-c-catman		.cat
+./usr/share/man/cat1/g++.0			comp-cxx-catman		gcccmds,.cat
+./usr/share/man/cat1/gcc.0			comp-c-catman		gcccmds,.cat
 ./usr/share/man/cat1/gcore.0			comp-debug-catman	.cat
-./usr/share/man/cat1/gcov.0			comp-debug-catman	.cat
+./usr/share/man/cat1/gcov.0			comp-debug-catman	gcccmds,.cat
 ./usr/share/man/cat1/gdb.0			comp-debug-catman	gdb,.cat
 ./usr/share/man/cat1/genassym.0			comp-util-catman	.cat
 ./usr/share/man/cat1/gprof.0			comp-debug-catman	bfd,.cat
@@ -6017,11 +6017,11 @@
 ./usr/share/man/man1/ar.1			comp-util-man		bfd,.man
 ./usr/share/man/man1/as.1			comp-util-man		bfd,.man
 ./usr/share/man/man1/asa.1			comp-fortran-man	.man
-./usr/share/man/man1/c++.1			comp-cxx-man		.man
+./usr/share/man/man1/c++.1			comp-cxx-man		gcccmds,.man
 ./usr/share/man/man1/c++filt.1			comp-cxx-man		bfd,.man
 ./usr/share/man/man1/c89.1			comp-c-man		.man
-./usr/share/man/man1/cc.1			comp-c-man		.man
-./usr/share/man/man1/cccp.1			comp-util-man		.man
+./usr/share/man/man1/cc.1			comp-c-man		gcccmds,.man
+./usr/share/man/man1/cccp.1			comp-util-man		gcccmds,.man
 ./usr/share/man/man1/config.1			comp-util-man		.man
 ./usr/share/man/man1/crunchgen.1		comp-c-man		.man
 ./usr/share/man/man1/crunchide.1		comp-c-man		.man
@@ -6031,10 +6031,10 @@
 ./usr/share/man/man1/fgen.1			comp-util-man		.man
 ./usr/share/man/man1/flex.1			comp-c-man		.man
 ./usr/share/man/man1/fpr.1			comp-fortran-man	.man
-./usr/share/man/man1/g++.1			comp-cxx-man		.man
-./usr/share/man/man1/gcc.1			comp-c-man		.man
+./usr/share/man/man1/g++.1			comp-cxx-man		gcccmds,.man
+./usr/share/man/man1/gcc.1			comp-c-man		gcccmds,.man
 ./usr/share/man/man1/gcore.1			comp-debug-man		.man
-./usr/share/man/man1/gcov.1			comp-debug-man		.man
+./usr/share/man/man1/gcov.1			comp-debug-man		gcccmds,.man
 ./usr/share/man/man1/gdb.1			comp-debug-man		gdb,.man
 ./usr/share/man/man1/genassym.1			comp-util-man		.man
 ./usr/share/man/man1/gprof.1			comp-debug-man		bfd,.man
Index: distrib/sets/lists/comp/tc.mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/comp/tc.mi,v
retrieving revision 1.13
diff -u -r1.13 tc.mi
--- distrib/sets/lists/comp/tc.mi	13 May 2006 07:17:54 -0000	1.13
+++ distrib/sets/lists/comp/tc.mi	17 May 2006 19:12:10 -0000
@@ -161,9 +161,9 @@
 ./usr/include/g++/vector.h			comp-cxx-include
 ./usr/lib/libgcc_p.a				comp-c-proflib		profile
 ./usr/libexec/f771				comp-fortran-bin	gcccmds
-./usr/share/man/cat1/f77.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/fort77.0			comp-fortran-catman	.cat
-./usr/share/man/cat1/g77.0			comp-fortran-catman	.cat
-./usr/share/man/man1/f77.1			comp-fortran-man	.man
-./usr/share/man/man1/fort77.1			comp-fortran-man	.man
-./usr/share/man/man1/g77.1			comp-fortran-man	.man
+./usr/share/man/cat1/f77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/cat1/fort77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/cat1/g77.0			comp-fortran-catman	gcccmds,.cat
+./usr/share/man/man1/f77.1			comp-fortran-man	gcccmds,.man
+./usr/share/man/man1/fort77.1			comp-fortran-man	gcccmds,.man
+./usr/share/man/man1/g77.1			comp-fortran-man	gcccmds,.man
Index: distrib/sets/lists/man/gcc.mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/man/gcc.mi,v
retrieving revision 1.4
diff -u -r1.4 gcc.mi
--- distrib/sets/lists/man/gcc.mi	13 May 2006 07:17:54 -0000	1.4
+++ distrib/sets/lists/man/gcc.mi	17 May 2006 19:12:10 -0000
@@ -1,4 +1,4 @@
 # $NetBSD: gcc.mi,v 1.4 2006/05/13 07:17:54 mrg Exp $
-./usr/share/info/g77.info			man-fortran-info	info
+./usr/share/info/g77.info			man-fortran-info	gcccmds,info
 ./usr/share/man/cat8/dbsym.0			man-sysutil-catman	bfd,.cat
 ./usr/share/man/man8/dbsym.8			man-sysutil-man		bfd,.man
Index: distrib/sets/lists/man/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/man/mi,v
retrieving revision 1.890
diff -u -r1.890 mi
--- distrib/sets/lists/man/mi	17 May 2006 14:05:52 -0000	1.890
+++ distrib/sets/lists/man/mi	17 May 2006 19:12:11 -0000
@@ -6,14 +6,14 @@
 ./usr/share/info/bfd.info			man-computil-info	bfd,info
 ./usr/share/info/binutils.info			man-computil-info	bfd,info
 ./usr/share/info/bzip2.info			man-util-info		info
-./usr/share/info/cpp.info			man-util-info		info
+./usr/share/info/cpp.info			man-util-info		gcccmds,info
 ./usr/share/info/cvs.info			man-cvs-info		cvs,info
 ./usr/share/info/cvsclient.info			man-cvs-info		cvs,info
 ./usr/share/info/dc.info			man-util-info		info
 ./usr/share/info/diff.info			man-util-info		info
 ./usr/share/info/dir				man-info-share		info
 ./usr/share/info/g++FAQ.info			man-obsolete		obsolete
-./usr/share/info/gcc.info			man-c-info		info
+./usr/share/info/gcc.info			man-c-info		gcccmds,info
 ./usr/share/info/gdb.info			man-debug-info		gdb,info
 ./usr/share/info/gdbint.info			man-debug-info		gdb,info
 ./usr/share/info/gettext.info			man-sys-info		info
@@ -89,7 +89,7 @@
 ./usr/share/man/cat1/compress.0			man-util-catman		.cat
 ./usr/share/man/cat1/cp.0			man-util-catman		.cat
 ./usr/share/man/cat1/cpio.0			man-util-catman		.cat
-./usr/share/man/cat1/cpp.0			man-util-catman		.cat
+./usr/share/man/cat1/cpp.0			man-util-catman		gcccmds,.cat
 ./usr/share/man/cat1/crontab.0			man-cron-catman		.cat
 ./usr/share/man/cat1/csh.0			man-util-catman		.cat
 ./usr/share/man/cat1/ctags.0			man-c-catman		.cat
@@ -136,7 +136,7 @@
 ./usr/share/man/cat1/fstat.0			man-util-catman		.cat
 ./usr/share/man/cat1/ftp.0			man-netutil-catman	.cat
 ./usr/share/man/cat1/g711conv.0			man-obsolete		obsolete
-./usr/share/man/cat1/gcpp.0			man-util-catman		.cat
+./usr/share/man/cat1/gcpp.0			man-util-catman		gcccmds,.cat
 ./usr/share/man/cat1/gencat.0			man-locale-catman	.cat
 ./usr/share/man/cat1/getconf.0			man-util-catman		.cat
 ./usr/share/man/cat1/getent.0			man-util-catman		.cat
@@ -2421,7 +2421,7 @@
 ./usr/share/man/man1/compress.1			man-util-man		.man
 ./usr/share/man/man1/cp.1			man-util-man		.man
 ./usr/share/man/man1/cpio.1			man-util-man		.man
-./usr/share/man/man1/cpp.1			man-util-man		.man
+./usr/share/man/man1/cpp.1			man-util-man		gcccmds,.man
 ./usr/share/man/man1/crontab.1			man-cron-man		.man
 ./usr/share/man/man1/csh.1			man-util-man		.man
 ./usr/share/man/man1/ctags.1			man-c-man		.man
@@ -2468,7 +2468,7 @@
 ./usr/share/man/man1/fstat.1			man-util-man		.man
 ./usr/share/man/man1/ftp.1			man-netutil-man		.man
 ./usr/share/man/man1/g711conv.1			man-obsolete		obsolete
-./usr/share/man/man1/gcpp.1			man-util-man		.man
+./usr/share/man/man1/gcpp.1			man-util-man		gcccmds,.man
 ./usr/share/man/man1/gencat.1			man-locale-man		.man
 ./usr/share/man/man1/getconf.1			man-util-man		.man
 ./usr/share/man/man1/getent.1			man-util-man		.man
Index: distrib/sets/lists/man/tc.mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/man/tc.mi,v
retrieving revision 1.5
diff -u -r1.5 tc.mi
--- distrib/sets/lists/man/tc.mi	13 May 2006 07:17:54 -0000	1.5
+++ distrib/sets/lists/man/tc.mi	17 May 2006 19:12:11 -0000
@@ -1,4 +1,4 @@
 # $NetBSD: tc.mi,v 1.5 2006/05/13 07:17:54 mrg Exp $
-./usr/share/info/g77.info			man-fortran-info	info
+./usr/share/info/g77.info			man-fortran-info	gcccmds,info
 ./usr/share/man/cat8/dbsym.0			man-sysutil-catman	bfd,.cat
 ./usr/share/man/man8/dbsym.8			man-sysutil-man		bfd,.man